#include "nms.h"


bool Solution::sort_score(Bbox box1, Bbox box2){
	return box1.score > box2.score ? true : false;
 	}

float Solution::iou(Bbox box1, Bbox box2){
	float x1 = max(box1.x1, box2.x1);
	float y1 = max(box1.y1, box2.y1);	
	float x2 = min(box1.x2, box2.x2);
	float y2 = min(box1.y2, box2.y2);	
	float w  = max(0.0f, x2 - x1 +1);
	float h  = max(0.0f, y2 - y1 + 1);
	float over_area = w * h;
	return over_area / ( ( ( box1.x2 - box1.x1 ) * ( box1.y2 - box2.y1) + (  box2.x2 - box2.x1 ) * ( box2.y2 - box2.y1 ) ) - over_area);
	}

std::vector<Bbox> Solution::nms(std::vector<Bbox>&vec_boxs, float threshold){
	vector<Bbox> results;
	std::sort(vec_boxs.begin(), vec_boxs.end(), sort_score);
	while(vec_boxs.size() > 0){
		results.push_back(vec_boxs[0]);
		int index = 1;
		while(index < vec_boxs.size()){
			float iou_value = iou(vec_boxs[0], vec_boxs[index]);
		//	cout<<"iou;"<<iou_value<<endl;
			if(iou_value > threshold)
				vec_boxs.erase(vec_boxs.begin() + index);
			else
				index++;
		}
		vec_boxs.erase(vec_boxs.begin());
	}
	return results;
}

